OZ_Windows	= {};

OZ_Config	= {};
OZ_Bars		= {};
OZ_Input	= {};

local function gg(text)
	local ret = getglobal(text)
	if(not ret) then
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF8800".."OzRaid: Failed to find: "..text);
	end
	return ret
end
local function print(text)
	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF"..text);
end

OZ_MAX_BARS = 42
OZ_MAX_BUFFS = 5
OZ_NWINDOWS	= 8
OZ_CURRENT_VERSION = 1.60

function OZ_SetupWindowPointers(n)
	OZ_Windows[n] = {
		-- Shortcuts to various UI elements
		["frame"]		=	gg("OzRaid_Frame"..n),
		["titleFrame"]	= gg("OzRaid_Frame"..n.."Title"),
		["name"]		= gg("OzRaid_Frame"..n.."TitleName"),
		["nameText"]	= gg("OzRaid_Frame"..n.."TitleNameText"),
		["background"]	= gg("OzRaid_Frame"..n.."TitleBackground"),
		["marker"]	= gg("OzRaid_Frame"..n.."TableMarker"),

		["close"]		= gg("OzRaid_Frame"..n.."TitleClose"),
		["options"]		= gg("OzRaid_Frame"..n.."TitleOptions"),

		["table"]		= gg("OzRaid_Frame"..n.."Table"),
		["bar"] = {},
		["n"]	= n,
		config	= OZ_Config[n]
	};
end

function OzDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, OzDropDown_Initialize, "MENU");
end

function OZ_showmenu()
	ToggleDropDownMenu(1, nil, OzDropDown, "cursor", 0, 0);
end

function OzDropDown_Initialize()
	local menu;
	local name;
	local id = nil;
	local unit = "mouseover"

	if ( UnitIsUnit(unit, "player") ) then
		menu = "SELF";
	elseif ( UnitIsUnit(unit, "pet") ) then
		menu = "PET";
	elseif ( UnitIsPlayer(unit) ) then
		id = UnitInRaid(unit);
		if ( id ) then
			menu = "RAID_PLAYER";
		elseif ( UnitInParty(unit) ) then
			menu = "PARTY";
		else
			menu = "PLAYER";
		end
	else
		menu = "RAID_TARGET_ICON";
		name = RAID_TARGET_ICON;
	end
	if ( menu ) then
		UnitPopup_ShowMenu(OzDropDown, menu, unit, UnitName(unit), id);
	end

end

function OZ_GetBar( window, x )
	if not window.bar[x] then
		local n = window.n
		local name = "OzRaid_Frame"..n.."TableRow"..x
		local bar

		if not ClickCastFrames then ClickCastFrames = {} end
		if not window.moveable then
			bar = CreateFrame( "Frame", name, window.table, "OZ_RowTemplate" )
--print("Added clickable bar")
		else
			bar = CreateFrame( "Frame", name, window.table, "OZ_RowTemplateINFO" )
--print("Added moveable bar")
		end
		
		local data = {
			["frame"]		= bar,
			["header"]		= gg(name.."Header"),
			["headerText"]	= gg(name.."HeaderText"),
			["barFrame"]	= gg(name.."BarFrame"),
			["bar"]			= gg(name.."BarFrameBar"),
			["glow"]		= gg(name.."BarFrameBarGlow"),
			["icon"]		= gg(name.."BarFrameIcon"),
			["iconTex"]		= gg(name.."BarFrameIconIcon"),
			["name"]		= gg(name.."BarFrameName"),
			["nameText"]	= gg(name.."BarFrameNameText"),
			["value"]		= gg(name.."BarFrameValue"),
			["valueText"]	= gg(name.."BarFrameValueText"),
			["buff"]		= { gg(name.."BarFrameBuff1"),
							      gg(name.."BarFrameBuff2"),
							      gg(name.."BarFrameBuff3"),
						              gg(name.."BarFrameBuff4"),
						              gg(name.."BarFrameBuff5") },
			["buffTex"]		= { gg(name.."BarFrameBuff1Icon"),
								gg(name.."BarFrameBuff2Icon"),
								gg(name.."BarFrameBuff3Icon"),
								gg(name.."BarFrameBuff4Icon"),
								gg(name.."BarFrameBuff5Icon") },
			["buffVal"]		= {nil,nil,nil,nil,nil},
		};
		window.bar[x] = data

		bar:SetID(x)
		if not window.moveable then
			SecureUnitButton_OnLoad( data.barFrame, "player", OZ_showmenu )
			ClickCastFrames[gg(name.."BarFrame")] = true
		end

		OZ_FormatRow( n, x )

		local config = OZ_Config[n]

		-- reset all the text sizes
		bw = config.textSize

		data.headerText:SetFont(STANDARD_TEXT_FONT,bw)
		if( config.outlineNames )then
			data.nameText:SetFont(STANDARD_TEXT_FONT,bw,"OUTLINE")
			data.valueText:SetFont(STANDARD_TEXT_FONT,bw,"OUTLINE")
		else
			data.nameText:SetFont(STANDARD_TEXT_FONT,bw)
			data.valueText:SetFont(STANDARD_TEXT_FONT,bw)
		end

		if x == 1 then
			bar:SetPoint("TOP", window.table, "TOP")
		else
			bar:SetPoint("TOP", window.bar[x-1].frame, "BOTTOM")
		end
	end
	return window.bar[x]
end

function OZ_SetupConfig(n)
	OZ_Config[n] = {
		["width"] = 90,
		["text"]		= "OzRaid "..n,
		["topCol"]		= {["r"]=0.0, ["g"]=1.0, ["b"]=1.0, ["a"]=0.5},
		["bottomCol"]	= {["r"]=0.0, ["g"]=0.0, ["b"]=0.6, ["a"]=0.5},
		["titleHeight"]		= 13,
		["hideTitle"]           = 1,
		["barHeight"]		= 12,
		["maxBars"]			= 40,
		["minBars"]			= 2,
		["buttonSize"]		= 10,

		["active"]			= 1,
		["textSize"]		= 10,
		["rangeFade"] 		= 1,
		["refresh"]			= 1,
		["barTexture"] = "Interface\\Addons\\OzRaid\\bar6",

		-- Functions to use
		input			= 1,
		filter			= {
								injuredVal			= 0.8,
								class = { DRUID		= 1,
										  HUNTER	= 1,
										  MAGE		= 1,
										  PALADIN	= 1,
										  PRIEST	= 1,
										  ROGUE		= 1,
										  SHAMAN	= 1,
										  WARLOCK	= 1,
										  WARRIOR	= 1,
										  PET		= 0,

										  TARGET	= 1,

										  RANGED	= 1,
										  MELEE		= 1,
										  HEALERS	= 1,
										  TANKS		= 1 },
								group = { 1, -- [1]
									    1, -- [2]
									    1, -- [3]
									    1, -- [4]
									    1, -- [5]
									    1, -- [6]
									    1, -- [7]
									    1, -- [8]		
 								},
								status=	{ healthy	 = 1,
										  injured	 = 1,
										  curable	 = 1,
										  notcurable = 1,
										  buffed	 = 1,
										  notbuffed	 = 1,
										  close = 1,
										  inrange = 1,
										  outofrange = 1,
										  dead = 1,
										  offline = 1,
										  online = 1,
										},
							  },
		sort1			= 3,
		sort2			= 0,
		sort3			= 0,

		heading			= {0,0,0},

		colour			= 2,
		icon			= 1,

		namePos			= 2,
		buffPos			= 3,
		buffSize		= 1,

		buffsPlayer		= {},
		buffsMob		= {},

		active			= 1,

		classNames		= 1,	-- Colour names by the class
		outlineNames	= 1,

		valuePos		= nil,	-- nil=off, 1=left, 2=bar middle, 3=bar right, 4=right
		valueType		= 1,	-- 1=number, 2=percent, 3=deficit

		nameOnStatus	= 1,	-- Change name colours given status
		barDebuffCol	= 1,	-- Colour bar if curable
		showDebuffIcon	= 0,	-- Icon if curable
	};

	-- Init buff arays with the class defaults
	local class,fileName = UnitClass("player")
	local i = 1
	for key,value in ipairs(OZ_BUFF_DEFAULT[fileName].Player) do
		local bName = "Interface\\Icons\\"..value[3]
		OZ_Config[n].buffsPlayer[key] = { value[1], value[2], bName }
	end

	for key,value in ipairs(OZ_BUFF_DEFAULT[fileName].Mob) do
		local bName = "Interface\\Icons\\"..value[3]
		OZ_Config[n].buffsMob[key] = { value[1], value[2], bName }
	end

	OZ_Bars[n]	= {
		["nBars"] = 0,
		["bar"] = {},
	};
end


function OZ_SetupSortBuffer()
	OZ_Input	= {
		["nBars"] = 0,
		["bar"] = {},
	};

	for x = 1 , OZ_MAX_BARS do
		OZ_Input.bar[x]= {
			-- Position of data in the raid roster
			["roster"]		= 0,
			["target"]		= 0,

			-- Bar values (min,max,fraction)
			["max"]			= 1000,
			["current"]		= 500,
			["value"]		= 0.5,

			-- Buffs
			["buffs"]		= {},
			["buffNames"]	= {},
			["debuffs"]		= nil,
		};
	end
end

function OZ_ConfigTitleBar(n)
	local window = OZ_GetWindowArray(n)
	if(OZ_Config[n].hideTitle)then
		window.titleFrame:SetHeight(0.1)
		window.titleFrame:Hide()
	else
		window.titleFrame:SetHeight(OZ_Config[n].titleHeight)
		window.titleFrame:Show()

		window.background:SetHeight(42)
		window.background:SetGradientAlpha("VERTICAL",
				OZ_Config[n].bottomCol.r,
				OZ_Config[n].bottomCol.g,
				OZ_Config[n].bottomCol.b,
				OZ_Config[n].bottomCol.a,
				OZ_Config[n].topCol.r,
				OZ_Config[n].topCol.g,
				OZ_Config[n].topCol.b,
				OZ_Config[n].topCol.a);

		local tw, th, bw;
		if(OZ_Config[n].hideButtons)then
			tw = OZ_Config[n].width - 6
			window.nameText:SetJustifyH("CENTER")
		else
			tw = OZ_Config[n].width - (OZ_Config[n].buttonSize*2) - 6
			window.nameText:SetJustifyH("LEFT")
		end
		th = OZ_Config[n].titleHeight
		bw = OZ_Config[n].buttonSize

		window.name:SetWidth(tw)
		window.name:SetHeight(th)

		window.nameText:SetText(OZ_Config[n].text)
		window.nameText:SetWidth(tw)
		window.nameText:SetHeight(th)
		window.nameText:Show()
		
		window.close:SetWidth( bw )
		window.options:SetWidth( bw )
		window.close:SetHeight( bw)
		window.options:SetHeight( bw )

		if(OZ_Config[n].hideButtons)then
			window.close:Hide()
			window.options:Hide()
		else
			window.close:Show()
			window.options:Show()
		end

	end

	if(OZ_Config[n].hideBG)then
		window.frame:SetBackdrop(nil)
	else
		window.frame:SetBackdrop({	bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		window.frame:SetBackdropColor(0.09, 0.09, 0.19)
		window.frame:SetBackdropBorderColor(1, 1, 1)
	end
end

function OZ_InitDefaultConfig()
	OZ_Config = {}
	for i=1,OZ_NWINDOWS do
		OZ_SetupConfig(i)
	end

	-- Temporarily disable the other windows till defaults are woring
	OZ_Config[2].active = nil
	OZ_Config[3].active = nil
	OZ_Config[4].active = nil
	OZ_Config[5].active = nil
	OZ_Config[6].active = nil
	OZ_Config[7].active = nil
	OZ_Config[8].active = nil

	OZ_Config.minimapAngle = 40
	OZ_Config.minimapDist  = 80
	OZ_Config.minimapShow  = 1
	OZ_Config.version = OZ_CURRENT_VERSION
end

function OzRaid_OnLoad()
--local alloc1 = gcinfo()
	local i
	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."OzRaid Loaded!");
	this:RegisterForDrag("LeftButton");
	OZ_SetupEvents()

	OZ_InitDefaultConfig()
	OZ_SetupRaidRoster()
	OZ_SetupSortBuffer()
--if(alloc1)then
--	local alloc2 = gcinfo()
--	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."Load 1 = "..alloc2 - alloc1.."kB");
--end

-- REMOVED: Apparently this breaks the target frame now *sigh*
--	if not _clickfixed then
--		__xps=PlaySound;
--		function PlaySound(snd)
--			if (snd~="igCharacterInfoTab") then
--				__xps(snd);
--			end
--		end
--		_clickfixed=1;
--	end 
end

function OzRaidLoadSavedVariables()
--local alloc1 = gcinfo()
	OZ_SetupAfterLoad()
--if(alloc1)then
--	local alloc2 = gcinfo()
--	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."Load 2 = "..alloc2 - alloc1.."kB");
--end
end

function OZ_InitWindow(n)
	local i

	OZ_SetupWindowPointers(n)
	local window = OZ_Windows[n]

	window.frame:RegisterForDrag("LeftButton") 
	window.frame:SetMovable(true)
	window.frame:SetUserPlaced(true)

	window.frame:SetWidth(OZ_Config[n].width)
	window.frame:SetHeight(200)
	window.frame.lastUpdate = 0

	window.marker:SetWidth( 60 )
	window.marker:SetHeight( 60 )

	OZ_ConfigTitleBar(n)

	OZ_SetFromConfig(n)
	-- reset all the text sizes
	OZ_CheckVisibility(n)
end

function OZ_SetFromConfig(n)
	local config = OZ_Config[n]
	-- reset all the text sizes
	bw = config.textSize
	local window = OZ_GetWindowArray(n)

	-- New - check if we are a moveable one or not...
	local status = config.filter.status
	local oldState = window.moveable
	if  (config.sort1==0 or config.sort1==3 or config.sort1==4) and
		(config.sort2==0 or config.sort2==3 or config.sort2==4) and
		status.healthy == 1 and
		status.injured == 1 and
		status.curable == 1 and
		status.notcurable == 1 and
		status.buffed == 1 and
		status.notbuffed == 1 and
		status.outofrange == 1 and
		status.dead == 1 and
		status.offline == 1 and
		status.online == 1 then
		-- Ok, this window has NO dynamic changes
		window.moveable = nil
--print("NEW: "..config.text.." is CLICKABLE")
	else
		-- Ok, we are a dynamically changing frame
		window.moveable = 1
--print("NEW: "..config.text.." is DYNAMIC (info only)")
	end
	-- We MUST check to see if we used to be protected
	if window.bar[1] and window.moveable ~= oldState then
		-- Ok, we have been initialised before, and so these bars are WRONG
		print("WARNING: "..config.text.." window needs to change security state. Please RELOAD UI!");
	end

	window.nameText:SetFont(STANDARD_TEXT_FONT,bw)

	for i=1,config.maxBars do
		if window.bar[i] then
			window.bar[i].headerText:SetFont(STANDARD_TEXT_FONT,bw)
			if( config.outlineNames )then
				window.bar[i].nameText:SetFont(STANDARD_TEXT_FONT,bw,"OUTLINE")
				window.bar[i].valueText:SetFont(STANDARD_TEXT_FONT,bw,"OUTLINE")
			else
				window.bar[i].nameText:SetFont(STANDARD_TEXT_FONT,bw)
				window.bar[i].valueText:SetFont(STANDARD_TEXT_FONT,bw)
			end
			OZ_FormatRow(n,i)
		else
			break
		end
	end

	OZ_ConfigTitleBar(n)
	OZ_SetMinimapPos()

	OZ_CheckVisibility(n)
end


local healSpells = {
	DRUID = "Healing Touch",
	SHAMAN = "Healing Wave",
	PRIEST = "Lesser Heal",
	PALADIN = "Holy Light"
};

OzPlayerHealSpell = nil

function OZ_SetupAfterLoad()

	local i,key,val
	-- Read the current players class
	key,val = UnitClass("player")
	if val then
		OzPlayerHealSpell = healSpells[val]
	end

	local version = 0
	if(	OZ_Config.version ) then
		version = OZ_Config.version
	end

	-- Update config with any new variables that have been added
	-- OLD version of the setting...
	if(version < 1.0)then
		-- Pre-relase version, reset all settings
		for i=1,6 do
			OZ_SetupConfig(i)
		end
	end
	if(version < 1.1)then
		for i=1,6 do
			OZ_Config[i].valuePos		= nil
			OZ_Config[i].valueType		= 2
			OZ_Config[i].nameOnStatus	= 1
			OZ_Config[i].barDebuffCol	= 1
			OZ_Config[i].showDebuffIcon	= nil
		end
	end
	if(version < 1.2)then
		OZ_Config.minimapAngle = 40
		OZ_Config.minimapDist  = 80
		OZ_Config.minimapShow  = 1

		OZ_SetupConfig(7)
		OZ_Config[7].active = nil
		OZ_SetupConfig(8)
		OZ_Config[8].active = nil
	end

	if(version < 1.4)then
		-- "Mark of the Wild/Gift of the Wild" ->"Mark of the Wild"
		for i=1,OZ_NWINDOWS do
			if(OZ_Config[i])then
				for key,val in ipairs(OZ_Config[i].buffsPlayer) do
					if( val[2] == "Mark of the Wild/Gift of the Wild" )then
						val[2] = "Mark of the Wild"
					end
					if( val[2] == "Prayer Of Fortitude" )then
						val[2] = "Prayer of Fortitude"
					end
				end
				-- Fill in icon base state
				if(not OZ_Config[i].showDebuffIcon)then
					OZ_Config[i].hideIcon = 1
				end
			end
		end
		OZ_Config[1].hideIcon = nil
	end

	if version<1.5 then
		-- Build a new style buff array

		local newArray
		for i=1,OZ_NWINDOWS do
			if(OZ_Config[i])then
				newArray = {}
				for key,val in ipairs(OZ_Config[i].buffsPlayer) do
					newArray[ val[3] ] = { val[1], val[2] }
				end
				OZ_Config[i].buffsPlayer = newArray

				newArray = {}
				for key,val in ipairs(OZ_Config[i].buffsMob) do
					newArray[ val[3] ] = { val[1], val[2] }
				end
				OZ_Config[i].buffsMob = newArray
			end
		end		
	end
	OZ_Config.version = OZ_CURRENT_VERSION

	OZ_UpdateRoster()
--	for i=1,OZ_NWINDOWS do
--		OZ_InitWindow(i)
--	end
	OZ_SetMinimapPos()

	OZ_Initialised = 1
end

function OZ_GetWindowArray( n )
	if(not OZ_Windows[n])then
		OZ_InitWindow(n)
	end
	return OZ_Windows[n]
end